<?php
/**
 * @package Demo Import
 * @since 1.0.0
 */

class ThemeWhizzie {

	protected $version = '1.1.0';

	/** @var string Current theme name, used as namespace in actions. */
	protected $theme_name = '';
	protected $theme_title = '';

	/** @var string Demo Import page slug and title. */
	protected $page_slug = '';
	protected $page_title = '';

	/** @var array Demo Import steps set by user. */
	protected $config_steps = array();
	public $parent_slug;
	/**
	 * Constructor
	 *
	 * @param $solar_generator_config	Our config parameters
	*/
	public function __construct( $solar_generator_config ) {
		$this->set_vars( $solar_generator_config );
		$this->init();
	}

	/**
	 * Set some settings
	 * @since 1.0.0
	 * @param $solar_generator_config	Our config parameters
	*/
	public function set_vars( $solar_generator_config ) {
		if( isset( $solar_generator_config['page_slug'] ) ) {
			$this->page_slug = esc_attr( $solar_generator_config['page_slug'] );
		}
		if( isset( $solar_generator_config['page_title'] ) ) {
			$this->page_title = esc_attr( $solar_generator_config['page_title'] );
		}
		if( isset( $solar_generator_config['steps'] ) ) {
			$this->config_steps = $solar_generator_config['steps'];
		}

		$current_theme = wp_get_theme();
		$this->theme_title = $current_theme->get( 'Name' );
		$this->theme_name = strtolower( preg_replace( '#[^a-zA-Z]#', '', $current_theme->get( 'Name' ) ) );
		$this->page_slug = apply_filters( $this->theme_name . '_theme_setup_wizard_page_slug', $this->theme_name . '-demoimport' );
		$this->parent_slug = apply_filters( $this->theme_name . '_theme_setup_wizard_parent_slug', '' );
	}

	/**
	 * Hooks and filters
	 * @since 1.0.0
	*/
	public function init() {
		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
		add_action( 'admin_menu', array( $this, 'menu_page' ) );
		add_action( 'wp_ajax_setup_widgets', array( $this, 'setup_widgets' ) );
	}

	public function enqueue_scripts() {
		wp_enqueue_style( 'demo-import-style', get_template_directory_uri() . '/demo-import/assets/css/demo-import-style.css');
		wp_register_script( 'demo-import-script', get_template_directory_uri() . '/demo-import/assets/js/demo-import-script.js', array( 'jquery' ), time() );
		wp_localize_script(
			'demo-import-script',
			'solar_generator_whizzie_params',
			array(
				'ajaxurl' 		=> admin_url( 'admin-ajax.php' ),
				'wpnonce' 		=> wp_create_nonce( 'whizzie_nonce' ),
				'verify_text'	=> esc_html( 'verifying', 'solar-generator' )
			)
		);
		wp_enqueue_script( 'demo-import-script' );
	}

	/**  Make a modal screen for the wizard **/
	public function menu_page() {
		add_menu_page( esc_html( $this->page_title ), esc_html( $this->page_title ), 'manage_options', $this->page_slug, array( $this, 'solar_generator_guide' ) ,'',40);
	}

	/** Make an interface for the wizard **/
	public function wizard_page() {
		/* If we arrive here, we have the filesystem */ ?>
		<div class="wrap">
			<?php echo '<div class="whizzie-wrap">';
				// The wizard is a list with only one item visible at a time
				$steps = $this->get_steps();
				echo '<ul class="whizzie-nav wizard-icon-nav">';?>
				<?php
					$stepI=1;
					foreach( $steps as $step ) {
						$stepAct=($stepI ==1)? 1 : 0;
						if( isset( $step['icon_text'] ) && $step['icon_text'] ) {
							echo '<li class="commom-cls nav-step-' . esc_attr( $step['id'] ) . '" wizard-steps="step-'.esc_attr( $step['id'] ).'" data-enable="'.$stepAct.'">
							<p>'.esc_attr( $step['icon_text'] ).'</p>
							</li>';
						}
					$stepI++;}
			 	echo '</ul>';
				echo '<ul class="whizzie-menu wizard-menu-page">';
				foreach( $steps as $step ) {
					$class = 'step step-' . esc_attr( $step['id'] );
					echo '<li data-step="' . esc_attr( $step['id'] ) . '" class="' . esc_attr( $class ) . '" >';
						$content = call_user_func( array( $this, $step['view'] ) );
						printf('<div class="wizard-button-wrapper">');
							if( isset( $step['button_text_one'] )) {
								printf(
									'<div class="button-wrap button-wrap-one">
										<a href="#" class="button button-primary do-it" data-callback="install_widgets" data-step="widgets"><p class="demo-type-text">%s</p></a>
									</div>',
									esc_html( $step['button_text_one'] )
								);
							}
						printf('</div>');
					echo '</li>';
				}
				echo '</ul>';
				?>
				<div class="step-loading"><span class="spinner">
					<img src="<?php echo esc_url(get_template_directory_uri().'/demo-import/assets/images/Spinner-Animaion.gif'); ?>">
				</span></div>
			<?php echo '</div>';?>
		</div>
	<?php }

	/**
	 * Set options for the steps
	 * @return Array
	*/
	public function get_steps() {
		if ( get_option('solar_generator_demo_imported') ) {
			return array(
				'done' => array(
					'id'        => 'done',
					'title'     => __( 'All Done', 'solar-generator' ),
					'icon'      => 'yes',
					'view'      => 'get_step_done',
					'callback'  => '',
					'icon_text' => 'View Site'
				)
			);
		}
		$dev_steps = $this->config_steps;
		$steps = array(
			'widgets' => array(
				'id'			=> 'widgets',
				'title'			=> __( 'Customizer', 'solar-generator' ),
				'icon'			=> 'welcome-widgets-menus',
				'view'			=> 'get_step_widgets',
				'callback'		=> 'install_widgets',
				'button_text_one'	=> __( 'Import Demo', 'solar-generator' ),
				'can_skip'		=> true,
				'icon_text'      => 'Import Demo'
			),
			'done' => array(
				'id'			=> 'done',
				'title'			=> __( 'All Done', 'solar-generator' ),
				'icon'			=> 'yes',
				'view'			=> 'get_step_done',
				'callback'		=> '',
				'icon_text'      => 'Done'
			)
		);
		// Iterate through each step and replace with dev config values
		if( $dev_steps ) {
			// Configurable elements - these are the only ones the dev can update from config.php
			$can_config = array( 'title', 'icon', 'button_text', 'can_skip' );
			foreach( $dev_steps as $dev_step ) {
				// We can only proceed if an ID exists and matches one of our IDs
				if( isset( $dev_step['id'] ) ) {
					$id = $dev_step['id'];
					if( isset( $steps[$id] ) ) {
						foreach( $can_config as $element ) {
							if( isset( $dev_step[$element] ) ) {
								$steps[$id][$element] = $dev_step[$element];
							}
						}
					}
				}
			}
		}
		return $steps;
	}

	/**    Print the content for the intro step     **/
		public function get_step_importer() { ?>
		<div class="summary">
			<p>
				<?php esc_html_e('Thank you for choosing this Solar Generator Theme. Using this quick setup wizard, you will be able to configure your new website and get it running in just a few minutes. Just follow these simple steps mentioned in the wizard and get started with your website.','solar-generator'); ?>
			</p>
		</div>
	<?php }

	/**   Print the content for the widgets step   **/
	public function get_step_widgets() { ?>
		<div class="summary">
			<p>
				<?php esc_html_e('This theme allows you to import demo content and add widgets. Install them using the button below. You can also update or deactivate them using the Customizer.','solar-generator'); ?>
			</p>
		</div>
	<?php }

	/** Print the content for the final step **/
	public function get_step_done() { ?>

		<div class="setup-finish">
			<p>
				<?php echo esc_html('Your demo content has been imported successfully. Click the finish button for more information.'); ?>
			</p>
			<div class="finish-buttons">
				<a href="<?php echo esc_url( admin_url( 'themes.php?page=solar-generator-getstart-page' ) ); ?>" class="wz-btn-customizer" target="_blank"><?php esc_html_e('About Solar Generator','solar-generator') ?></a>
				<a href="<?php echo esc_url(admin_url('/customize.php')); ?>" class="wz-btn-customizer" target="_blank"><?php esc_html_e('Customize Your Demo','solar-generator') ?></a>
				<a href="<?php echo esc_url(home_url()); ?>" class="wz-btn-visit-site" target="_blank"><?php esc_html_e('Visit Your Site','solar-generator'); ?></a>
			</div>
			<div class="finish-buttons">
				<a href="<?php echo esc_url(admin_url()); ?>" class="button button-primary"><?php esc_html_e('Finish','solar-generator'); ?></a>
			</div>
		</div>

	<?php }

	//................................................. MENUS .................................................//
		
	public function solar_generator_customizer_nav_menu() {
		// ------- Create Primary Menu --------
		$solar_generator_themename = 'Solar Generator'; // Ensure the theme name is set
		$solar_generator_menuname = $solar_generator_themename . ' Primary Menu';
		$solar_generator_menulocation = 'menu-1';
		$solar_generator_menu_exists = wp_get_nav_menu_object($solar_generator_menuname);

		if (!$solar_generator_menu_exists) {
			$solar_generator_menu_id = wp_create_nav_menu($solar_generator_menuname);

			// Home
			wp_update_nav_menu_item($solar_generator_menu_id, 0, array(
				'menu-item-title' => __('Home', 'solar-generator'),
				'menu-item-classes' => 'home',
				'menu-item-url' => home_url('/'),
				'menu-item-status' => 'publish'
			));

			// About
			$solar_generator_page_about = get_page_by_path('about');
			if($solar_generator_page_about){
				wp_update_nav_menu_item($solar_generator_menu_id, 0, array(
					'menu-item-title' => __('About', 'solar-generator'),
					'menu-item-classes' => 'about',
					'menu-item-url' => get_permalink($solar_generator_page_about),
					'menu-item-status' => 'publish'
				));
			}

			// Services
			$solar_generator_page_services = get_page_by_path('services');
			if($solar_generator_page_services){
				wp_update_nav_menu_item($solar_generator_menu_id, 0, array(
					'menu-item-title' => __('Services', 'solar-generator'),
					'menu-item-classes' => 'services',
					'menu-item-url' => get_permalink($solar_generator_page_services),
					'menu-item-status' => 'publish'
				));
			}

			wp_update_nav_menu_item( $solar_generator_menu_id, 0, array(
				'menu-item-title'  => __( 'Projects', 'solar-generator' ),
				'menu-item-url'    => '#',
				'menu-item-status' => 'publish',
			) );

			wp_update_nav_menu_item( $solar_generator_menu_id, 0, array(
				'menu-item-title'  => __( 'Pages', 'solar-generator' ),
				'menu-item-url'    => '#',
				'menu-item-status' => 'publish',
			) );

			wp_update_nav_menu_item( $solar_generator_menu_id, 0, array(
				'menu-item-title'  => __( 'Team', 'solar-generator' ),
				'menu-item-url'    => '#',
				'menu-item-status' => 'publish',
			) );

			// Blog
			$solar_generator_page_blog = get_page_by_path('blog');
			if($solar_generator_page_blog){
				wp_update_nav_menu_item($solar_generator_menu_id, 0, array(
					'menu-item-title' => __('Blog', 'solar-generator'),
					'menu-item-classes' => 'blog',
					'menu-item-url' => get_permalink($solar_generator_page_blog),
					'menu-item-status' => 'publish'
				));
			}

			// Contact Us
			$solar_generator_page_contact = get_page_by_path('contact');
			if($solar_generator_page_contact){
				wp_update_nav_menu_item($solar_generator_menu_id, 0, array(
					'menu-item-title' => __('Contact Us', 'solar-generator'),
					'menu-item-classes' => 'contact',
					'menu-item-url' => get_permalink($solar_generator_page_contact),
					'menu-item-status' => 'publish'
				));
			}

			// Assign menu to location if not set
			if (!has_nav_menu($solar_generator_menulocation)) {
				$solar_generator_locations = get_theme_mod('nav_menu_locations');
				$solar_generator_locations[$solar_generator_menulocation] = $solar_generator_menu_id; // Use $solar_generator_menu_id here
				set_theme_mod('nav_menu_locations', $solar_generator_locations);
			}
		}
	}

	public function solar_generator_customizer_nav_social_menu() {

		// ------- Create Social Menu --------
		$solar_generator_menuname = $solar_generator_themename . 'Social Menu';
		$solar_generator_menulocation = 'social-menu';
		$solar_generator_menu_exists = wp_get_nav_menu_object( $solar_generator_menuname );

		if( !$solar_generator_menu_exists){
			$solar_generator_menu_id = wp_create_nav_menu($solar_generator_menuname);

			wp_update_nav_menu_item( $solar_generator_menu_id, 0, array(
				'menu-item-title'  => __( 'Facebook', 'solar-generator' ),
				'menu-item-url'    => 'https://www.facebook.com',
				'menu-item-status' => 'publish',
			) );

			wp_update_nav_menu_item( $solar_generator_menu_id, 0, array(
				'menu-item-title'  => __( 'Pinterest', 'solar-generator' ),
				'menu-item-url'    => 'https://www.pinterest.com',
				'menu-item-status' => 'publish',
			) );

			wp_update_nav_menu_item( $solar_generator_menu_id, 0, array(
				'menu-item-title'  => __( 'Twitter', 'solar-generator' ),
				'menu-item-url'    => 'https://www.twitter.com',
				'menu-item-status' => 'publish',
			) );

			wp_update_nav_menu_item( $solar_generator_menu_id, 0, array(
				'menu-item-title'  => __( 'Youtube', 'solar-generator' ),
				'menu-item-url'    => 'https://www.youtube.com',
				'menu-item-status' => 'publish',
			) );

			wp_update_nav_menu_item( $solar_generator_menu_id, 0, array(
				'menu-item-title'  => __( 'Instagram', 'solar-generator' ),
				'menu-item-url'    => 'https://www.instagram.com',
				'menu-item-status' => 'publish',
			) );

			if( !has_nav_menu( $solar_generator_menulocation ) ){
					$locations = get_theme_mod('nav_menu_locations');
					$locations[$solar_generator_menulocation] = $solar_generator_menu_id;
					set_theme_mod( 'nav_menu_locations', $locations );
			}
		}
	}

	/**
	* Imports the Demo Content
	* @since 1.1.0
	*/
	public function setup_widgets() {

		//................................................. MENU PAGES .................................................//
		
			$solar_generator_home_id='';
			$solar_generator_home_content = '';

			$solar_generator_home_title = 'Home';
			$solar_generator_home = array(
					'post_type' => 'page',
					'post_title' => $solar_generator_home_title,
					'post_content'  => $solar_generator_home_content,
					'post_status' => 'publish',
					'post_author' => 1,
					'post_slug' => 'home'
			);
			$solar_generator_home_id = wp_insert_post($solar_generator_home);

			//Set the home page template
			add_post_meta( $solar_generator_home_id, '_wp_page_template', 'revolution-home.php' );

			//Set the static front page
			$solar_generator_home = get_page_by_title( 'Home' );
			update_option( 'page_on_front', $solar_generator_home->ID );
			update_option( 'show_on_front', 'page' );


			// Create a posts page and assign the template
			$solar_generator_blog_title = 'Blog';
			$solar_generator_blog_check = get_page_by_path('blog');
			if (!$solar_generator_blog_check) {
				$solar_generator_blog = array(
					'post_type'    => 'page',
					'post_title'   => $solar_generator_blog_title,
					'post_status'  => 'publish',
					'post_author'  => 1,
					'post_name'    => 'blog' // Unique slug for the blog page
				);
				$solar_generator_blog_id = wp_insert_post($solar_generator_blog);

				// Set the posts page
				if (!is_wp_error($solar_generator_blog_id)) {
					update_option('page_for_posts', $solar_generator_blog_id);
				}
			}

			// Create a Contact Us page and assign the template
			$solar_generator_contact_title = 'Contact Us';
			$solar_generator_contact_check = get_page_by_path('contact');
			if (!$solar_generator_contact_check) {
				$solar_generator_contact = array(
					'post_type'    => 'page',
					'post_title'   => $solar_generator_contact_title,
					'post_content'   => '"More About The Free Solar WordPress Theme"
										The Free Solar WordPress Theme is built with stunning visuals, retina-ready graphics, and interactive design elements to create a professional-looking website. The theme offers personalization options, allowing you to customize colors, typography, and layouts to match your brand identity. With a drag-and-drop page builder, you can effortlessly create unique pages without any coding knowledge. Featuring a clean and minimal design, this theme enhances readability while maintaining a visually appealing layout. With custom widgets, banner sections, and mobile-friendly navigation, the theme ensures a seamless experience on all devices.

										The Free Solar WordPress Theme is an excellent choice for professionals in the solar energy industry looking to build an informative and visually stunning website. Designed with clean energy advocates, solar panel installers, and renewable energy companies in mind, this theme provides a sleek, well-structured layout that improves user engagement. With sections dedicated to solar panel installation, off-grid and on-grid solar solutions, solar battery storage, and hybrid solar systems, the theme ensures that visitors can easily find relevant information. The free theme also includes interactive elements, dynamic animations, and modern typography to create an engaging user experience. The Free Solar WordPress Theme supports blog sections where you can share solar power trends, net metering insights, and updates on government solar incentives to educate your audience.

										Additionally, the Free Solar WordPress Theme is highly developer-friendly, crafted with secure, optimized, and clean code to ensure top-notch performance and seamless functionality. Bootstrap framework integration enhances the theme’s responsiveness, making it fully accessible across desktops, tablets, and smartphones, ensuring a smooth user experience on any device. Whether you specialize in residential solar solutions, commercial solar projects, or industrial solar installations, this theme is designed to beautifully showcase your services while maintaining a professional and visually engaging layout. With integrated lead generation tools, businesses can effortlessly convert website visitors into potential clients, boosting conversions and engagement. A dedicated testimonial section allows satisfied customers to share their experiences, while the case study area showcases successful solar panel installations and renewable energy projects, fostering trust among potential clients.',
					'post_status'  => 'publish',
					'post_author'  => 1,
					'post_name'    => 'contact' // Unique slug for the Contact Us page
				);
				wp_insert_post($solar_generator_contact);
			}

			// Create a About page and assign the template
			$solar_generator_about_title = 'About';
			$solar_generator_about_check = get_page_by_path('about');
			if (!$solar_generator_about_check) {
				$solar_generator_about = array(
					'post_type'    => 'page',
					'post_title'   => $solar_generator_about_title,
					'post_content'   => '"More About The Free Solar WordPress Theme"
										The Free Solar WordPress Theme is built with stunning visuals, retina-ready graphics, and interactive design elements to create a professional-looking website. The theme offers personalization options, allowing you to customize colors, typography, and layouts to match your brand identity. With a drag-and-drop page builder, you can effortlessly create unique pages without any coding knowledge. Featuring a clean and minimal design, this theme enhances readability while maintaining a visually appealing layout. With custom widgets, banner sections, and mobile-friendly navigation, the theme ensures a seamless experience on all devices.

										The Free Solar WordPress Theme is an excellent choice for professionals in the solar energy industry looking to build an informative and visually stunning website. Designed with clean energy advocates, solar panel installers, and renewable energy companies in mind, this theme provides a sleek, well-structured layout that improves user engagement. With sections dedicated to solar panel installation, off-grid and on-grid solar solutions, solar battery storage, and hybrid solar systems, the theme ensures that visitors can easily find relevant information. The free theme also includes interactive elements, dynamic animations, and modern typography to create an engaging user experience. The Free Solar WordPress Theme supports blog sections where you can share solar power trends, net metering insights, and updates on government solar incentives to educate your audience.

										Additionally, the Free Solar WordPress Theme is highly developer-friendly, crafted with secure, optimized, and clean code to ensure top-notch performance and seamless functionality. Bootstrap framework integration enhances the theme’s responsiveness, making it fully accessible across desktops, tablets, and smartphones, ensuring a smooth user experience on any device. Whether you specialize in residential solar solutions, commercial solar projects, or industrial solar installations, this theme is designed to beautifully showcase your services while maintaining a professional and visually engaging layout. With integrated lead generation tools, businesses can effortlessly convert website visitors into potential clients, boosting conversions and engagement. A dedicated testimonial section allows satisfied customers to share their experiences, while the case study area showcases successful solar panel installations and renewable energy projects, fostering trust among potential clients.',
					'post_status'  => 'publish',
					'post_author'  => 1,
					'post_name'    => 'about' // Unique slug for the About page
				);
				wp_insert_post($solar_generator_about);
			}

			// Create a Services page and assign the template
			$solar_generator_services_title = 'Services';
			$solar_generator_services_check = get_page_by_path('services');
			if (!$solar_generator_services_check) {
				$solar_generator_services = array(
					'post_type'    => 'page',
					'post_title'   => $solar_generator_services_title,
					'post_content'   => '"More About The Free Solar WordPress Theme"
										The Free Solar WordPress Theme is built with stunning visuals, retina-ready graphics, and interactive design elements to create a professional-looking website. The theme offers personalization options, allowing you to customize colors, typography, and layouts to match your brand identity. With a drag-and-drop page builder, you can effortlessly create unique pages without any coding knowledge. Featuring a clean and minimal design, this theme enhances readability while maintaining a visually appealing layout. With custom widgets, banner sections, and mobile-friendly navigation, the theme ensures a seamless experience on all devices.

										The Free Solar WordPress Theme is an excellent choice for professionals in the solar energy industry looking to build an informative and visually stunning website. Designed with clean energy advocates, solar panel installers, and renewable energy companies in mind, this theme provides a sleek, well-structured layout that improves user engagement. With sections dedicated to solar panel installation, off-grid and on-grid solar solutions, solar battery storage, and hybrid solar systems, the theme ensures that visitors can easily find relevant information. The free theme also includes interactive elements, dynamic animations, and modern typography to create an engaging user experience. The Free Solar WordPress Theme supports blog sections where you can share solar power trends, net metering insights, and updates on government solar incentives to educate your audience.

										Additionally, the Free Solar WordPress Theme is highly developer-friendly, crafted with secure, optimized, and clean code to ensure top-notch performance and seamless functionality. Bootstrap framework integration enhances the theme’s responsiveness, making it fully accessible across desktops, tablets, and smartphones, ensuring a smooth user experience on any device. Whether you specialize in residential solar solutions, commercial solar projects, or industrial solar installations, this theme is designed to beautifully showcase your services while maintaining a professional and visually engaging layout. With integrated lead generation tools, businesses can effortlessly convert website visitors into potential clients, boosting conversions and engagement. A dedicated testimonial section allows satisfied customers to share their experiences, while the case study area showcases successful solar panel installations and renewable energy projects, fostering trust among potential clients.',
					'post_status'  => 'publish',
					'post_author'  => 1,
					'post_name'    => 'services' // Unique slug for the Services page
				);
				wp_insert_post($solar_generator_services);
			}


		// ------------------------------------------ Header -------------------------------------- //

			set_theme_mod('solar_generator_header_info_phone','Toll Free: +1234-567-7890');
			set_theme_mod('solar_generator_header_info_email','solar123456@example.com');

			set_theme_mod('solar_generator_facebook_link_option','#');
			set_theme_mod('solar_generator_twitter_link_option','#');
			set_theme_mod('solar_generator_instagram_link_option','#');
			set_theme_mod('solar_generator_linkedin_link_option','#');
			set_theme_mod('solar_generator_pinterest_link_option','#');
			set_theme_mod('solar_generator_youtube_link_option','#');

			set_theme_mod('solar_generator_header_button_text','Get A Quote');
			set_theme_mod('solar_generator_header_button_link','#');
			set_theme_mod('solar_generator_enable_slider',1);
			set_theme_mod('solar_generator_projetcs_sec_show',1);
			set_theme_mod('solar_generator_header_search',true);
			

		// ------------------------------------------ Slider Section -------------------------------------- //

			for($i=1;$i<=3;$i++){
				set_theme_mod( 'solar_generator_slider_image'.$i,get_template_directory_uri().'/revolution/assets/images/slider'.$i.'.png' );
				set_theme_mod( 'solar_generator_slider_top_text'.$i, 'Welcome To Solar Energy' );
				set_theme_mod( 'solar_generator_slider_heading'.$i, 'Powering A Greener Future With Solar' );
				set_theme_mod( 'solar_generator_slider_text'.$i, 'Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry.' );
				set_theme_mod( 'solar_generator_slider_button1_text'.$i, 'Read More' );
				set_theme_mod( 'solar_generator_slider_button1_link'.$i, '#' );
				set_theme_mod( 'solar_generator_slider_button2_text'.$i, 'Request A Quote' );
				set_theme_mod( 'solar_generator_slider_button2_link'.$i, '#' );
			}

		// ------------------------------------------ Chef Section -------------------------------------- //

			set_theme_mod('solar_generator_projetcs_main_text','Our Works');
			set_theme_mod('solar_generator_projetcs_main_heading','OUR BEST PROJECT');

			$tab_title=array('All','Commercial','Eco-maintenance','Solar Windmills','Solar Energy','Wind Power');
			for($i=1;$i<=6;$i++) {
				set_theme_mod( 'solar_generator_projetcs_text'.$i, $tab_title[$i-1] );
			}

			wp_delete_post(1);
			$blog_title = array(
				'Solar Generators',
				'Benefits of Solar Generators',
				'Top Solar Generators',
				'Solar Power for Construction',
				'Installing Solar Power',
				'Eco-maintenance Solar Power',
			);
			for($i=1;$i<=6;$i++){
				$title =$blog_title[$i-1];
				$content = 'Lorem Ipsum is simply dummy text.';

				// Create post object
				$my_post = array(
					'post_title'    => wp_strip_all_tags( $title ),
					'post_content'  => $content,
					'post_status'   => 'publish',
					'post_type'     => 'post',
				);

				// Insert the post into the database
				$post_id = wp_insert_post( $my_post );

				$image_url = get_template_directory_uri().'/revolution/assets/images/blogs'.$i.'.png';

				$image_name= 'blogs'.$i.'.png';
				$upload_dir       = wp_upload_dir();
				// Set upload folder
				$image_data       = file_get_contents($image_url);
				// Get image data
				$unique_file_name = wp_unique_filename( $upload_dir['path'], $image_name );
				// Generate unique name
				$filename= basename( $unique_file_name );
				// Create image file name
				// Check folder permission and define file location
				if( wp_mkdir_p( $upload_dir['path'] ) ) {
					$file = $upload_dir['path'] . '/' . $filename;
				} else {
					$file = $upload_dir['basedir'] . '/' . $filename;
				}
				// Create the image  file on the server
				if ( ! function_exists( 'WP_Filesystem' ) ) {
					require_once( ABSPATH . 'wp-admin/includes/file.php' );
				}

				WP_Filesystem();
				global $wp_filesystem;

				if ( ! $wp_filesystem->put_contents( $file, $image_data, FS_CHMOD_FILE ) ) {
					wp_die( 'Error saving file!' );
				}
				// Check image file type
				$wp_filetype = wp_check_filetype( $filename, null );
				// Set attachment data
				$attachment = array(
				'post_mime_type' => $wp_filetype['type'],
				'post_title'     => sanitize_file_name( $filename ),
				'post_content'   => '',
				'post_type'     => 'post',
				'post_status'    => 'inherit'
				);
				// Create the attachment
				$attach_id = wp_insert_attachment( $attachment, $file, $post_id );
				// Include image.php
				require_once(ABSPATH . 'wp-admin/includes/image.php');
				// Define attachment metadata
				$attach_data = wp_generate_attachment_metadata( $attach_id, $file );
				// Assign metadata to attachment
				wp_update_attachment_metadata( $attach_id, $attach_data );
				// And finally assign featured image to post
				set_post_thumbnail( $post_id, $attach_id );
			}


		$this->solar_generator_customizer_nav_menu();
		$this->solar_generator_customizer_nav_social_menu();
		update_option('solar_generator_demo_imported', true);
	}

	public function solar_generator_guide() {
		$display_string = '';
		$return = add_query_arg( array()) ;
		$theme = wp_get_theme( 'solar-generator' );
		?>
		<div class="wrapper-info get-stared-page-wrap">
			<div class="wrapper-info-content">
				<div class="buynow__">
					<h2><?php esc_html_e( 'Welcome to Solar Generator', 'solar-generator' ); ?> <span class="version">Version: <?php echo esc_html($theme['Version']);?></span></h2>
					<p><?php esc_html_e('The quick setup wizard will assist you in configuring your new website. This wizard will import the demo content.', 'solar-generator'); ?></p>
				</div>
				<div class="buynow_">
					<a target="_blank" class="buynow_themepage" href="<?php echo esc_url('https://www.revolutionwp.com/products/solar-energy-wordpress-theme'); ?>"><?php echo esc_html__('Go Premium Now', 'solar-generator'); ?></a>
				</div>
			</div>
			<div class="tab-sec theme-option-tab">
				<div id="demo_offer" class="tabcontent open">
					<?php $this->wizard_page(); ?>
				</div>
			</div>
		</div>
	<?php }
}